// A minimal Win32 console app

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>		// file io

#include <windows.h>


char * pascal FindFname(char *Path)      // find filename in path
{
char *s=Path;
    for(;*s;) s++;
    for(;*(s-1)!='\\' && s>Path;s--){}
    return s;
}


//--------------------------------------------------LoadFile---------------
HGLOBAL LoadFile(char *filename, unsigned int *filesize)
{
HANDLE file;
HGLOBAL P;
unsigned long numofread;
  if( (file=CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,
    NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL)) == INVALID_HANDLE_VALUE )
  {
    return NULL;
  }
  *filesize=GetFileSize(file,NULL);
  if ( (P=GlobalAlloc(GMEM_FIXED | GMEM_ZEROINIT, *filesize+MAX_PATH)) != NULL ) {
    byte *bp = (byte *)P;
    if( ReadFile(file,(byte *)bp,*filesize,&numofread,NULL ) == FALSE)
    {
      GlobalFree(P);
      P=0;
    } else {
      *((byte *)bp + *filesize)=0x0d; // terminate data with 0x0d
      *((byte *)bp + *filesize)=0x0a; // terminate data with 0x0d
      *((byte *)bp + *filesize)=0; // terminate data with NULL
    }
  }
  CloseHandle(file);
  return P;           // return pointer to  memory block
}

//------------------------------------------------------------------------
int CountLines(HGLOBAL F,unsigned int l)
{
int c=0;
int i=0;
char *pb=(char *)F;
	for(i=0;i<l;i++, pb++)  if(*pb==0x0d) c++;
	return c;
}

//------------------------------------------------------------------------
int GetName(char *dest, HGLOBAL f, int i)
{
char *d=(char *)f;
	for(;i>1;i--,d++)
		while(*d!=0x0d) d++;
	while(*d==0x0d || *d==0x0a) d++;
	while(*d!=0x0d && *d!=0x0a && *d!=0) *dest++=*d++;
	*dest=0;
	return 1;
}


//------------------------------------------------------------------------
int main(int argc, char **argv) 
{
int c,pick,r=1,done=0;
HGLOBAL Files;
HGLOBAL FilesDone;
unsigned int len,dlen;
char fsel[MAX_PATH];
char dest[MAX_PATH];
char *ca,*cb;
DWORD dwsize;
	if(argc<3) {
		printf(">RNDFILE listfile destination\nrndfile selects a random file from the list and copies it to destination");
		return 1;
	}
	dlen=0;
	if( (FilesDone=LoadFile("donelist",&dlen))==NULL ) {
		FilesDone = GlobalAlloc(GMEM_FIXED | GMEM_ZEROINIT, MAX_PATH+32); //) != NULL ) {
	}
	
	if( (Files=LoadFile(argv[1],&len))!=NULL ) {
	
		c=CountLines(Files,len);
	
	} else {
	  printf("File: %s not found",argv[2]);
	  return 1;
	}

	srand(GetTickCount());
	
again:
	// Pick one
	done++;
	pick = c * (double)((double)rand()/(double)RAND_MAX);  //RAND_MAX
	
	// get name
	if(GetName(fsel, Files, pick)) {
	
		// check done list
		if(strstr((char *)FilesDone,fsel)!=NULL) {
		  printf("Selecting new file %d\n",pick);
		  if(done<c) 
				goto again;
		}
		
		strcpy(dest,argv[2]);
		cb=dest+strlen(dest);
		while(cb>dest && *cb!='.') cb--;
		if(cb==dest) {// there is no '.'
  		cb=dest+strlen(dest); // add to end
  		//*cb++='.';
  	}
		
		ca=fsel+strlen(fsel);
		while(ca>fsel && *ca!='.') ca--;
		if(ca==fsel) {// there is no '.'
  	} else {
  		while(*ca) *cb++=*ca++;
  		*cb=0;
  	}

		// add to done list
  	HANDLE lf;
  	if( (lf=CreateFile("DoneList",GENERIC_WRITE	,0, NULL, OPEN_ALWAYS	,FILE_ATTRIBUTE_ARCHIVE,NULL	)) != INVALID_HANDLE_VALUE) {
  	
  	  dwsize=SetFilePointer(lf,0,0,FILE_END);
  	  char ch=0x0d;
  	  if(dwsize) {
	  	  WriteFile(lf,&ch,1,&dwsize,NULL);
  		  ch=0x0a;
  		  WriteFile(lf,&ch,1,&dwsize,NULL);
  	  }
  	  WriteFile(lf,fsel,strlen(fsel),&dwsize,NULL);
  	  
  		CloseHandle(lf);
  	}
  	CopyFile(fsel, dest, FALSE); // copy and overwrite
		r=0; // return 0 for OK;
	} 
	GlobalFree(Files);	
	GlobalFree(FilesDone);	
	printf("%d files picked %d\n%s\n",c,pick,fsel);
	return 0;
}
